/*
 * ipotenusa.c 
 *
 * programma di esempio per la dichiarazione e definizione di
 * funzioni.
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double leggi_double(void);
double quad(double a);
double ipot(double a, double b);

int main()
{
  double a, b;

  a = leggi_double();
  b = leggi_double();
  printf("Ipotenusa: %lf\n", ipot(a, b));

  return 0;
}

/* 
 * Richiede un valore all'utente e lo restituisce
 * convertito in double.
 */
double leggi_double(void)
{
  char buf[100];

  fgets(buf, sizeof(buf), stdin);
  return atof(buf);
}

double quad(double a)
{
  return a * a;
}

/* 
 * La funzione calcola e restituisce l'iponenusa
 * di un triangolo rettangolo i cui cateti sono a e b.
 */
double ipot(double a, double b)
{
  return sqrt(quad(a) + quad(b));
}
