/*
 * typedef_define.c
 *
 * esempi di utilizzo di typedef e define
 */
#include <stdio.h>

#define T_CHAR_D char
#define T_CHARP_D char *

typedef char t_char_t;
typedef char * t_charp_t;

typedef char t_char_vect[];

int main()
{
  t_char_vect v = "la mia stringa\n"; 

  /* due dichiarazioni equivalenti */
  t_char_t n2;
  T_CHAR_D n1;

  //unsigned t_char_t n3;  /* questo non si può fare!!! */
  unsigned T_CHAR_D n4;

  t_charp_t p1, p2, p3;   /* sono tutti puntatori a char */
  T_CHARP_D p4, p5, p6;   /* solo il primo è un puntatore! */

  printf("%ld %ld %ld\n", sizeof(p1), sizeof(p2), sizeof(p3));
  printf("%ld %ld %ld\n", sizeof(p4), sizeof(p5), sizeof(p6));

  return 0;
}
