#include <stdio.h>

void stampa_bit(void *ptr)
{
  int i, x;

  for (i = 0; i < 32; i++) {
    x = (*(int *)(ptr) >> i) & 0x01;
    printf("%d", x);
  }
  printf("\n");
}

int main() 
{
  int a = 10;
  float b = 3.14;
  void *ptr;   /* dichiarazione del puntatore a void */

  /* assegna al void pointer l'indirizzo dell'int */
  ptr = &a;
  printf("Valore intero 0x%p = %d\n", ptr, *((int*)(ptr)));
  stampa_bit(ptr);

  /* assegna al void pointer l'indirizzo del float */
  ptr = &b;
  printf("Valore float  0x%p = %f\n", ptr, *((float*)(ptr)));
  stampa_bit(ptr);
  return 0;
}
